Halide 22.0.0 Halide compiler and libraries

Loading...
Searching...
No Matches
Public Member Functions | Protected Types | Protected Member Functions | List of all members
Halide::Internal::GeneratorOutputImpl< T > Class Template Reference

`#include <Generator.h>`

Inheritance diagram for Halide::Internal::GeneratorOutputImpl< T >:

## Public Member Functions
template<typename... Args, typename T2 = T, std::enable_if_t<!std::is_array_v< T2 > > * = nullptr>
FuncRef | operator() (Args &&...args) const
template<typename ExprOrVar , typename T2 = T, std::enable_if_t<!std::is_array_v< T2 > > * = nullptr>
FuncRef | operator() (std::vector< ExprOrVar > args) const
template<typename T2 = T, std::enable_if_t<!std::is_array_v< T2 > > * = nullptr>
| operator Func () const
template<typename T2 = T, std::enable_if_t<!std::is_array_v< T2 > > * = nullptr>
| operator Stage () const
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > > * = nullptr>
size_t | size () const
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > > * = nullptr>
const ValueType & | operator[] (size_t i) const
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > > * = nullptr>
const ValueType & | at (size_t i) const
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > > * = nullptr>
std::vector< ValueType >::const_iterator | begin () const
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > > * = nullptr>
std::vector< ValueType >::const_iterator | end () const
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > &&std::rank_v< T2 >==1 &&std::extent_v< T2, 0 >==0 > * = nullptr>
void | resize (size_t size)
Public Member Functions inherited from Halide::Internal::GeneratorOutputBase
void | set_type (const std::vector< Type > &types)
| Set types dynamically for tuple outputs.
| ~GeneratorOutputBase () override
void | set_type (const Type &type)
| Forward schedule-related methods to the underlying Func.
Public Member Functions inherited from Halide::Internal::GIOBase
virtual | ~GIOBase ()=default
void | set_type (const Type &type)
void | set_dimensions (int dims)
void | set_array_size (int size)
| GIOBase (const GIOBase &)=delete
GIOBase & | operator= (const GIOBase &)=delete
| GIOBase (GIOBase &&)=delete
GIOBase & | operator= (GIOBase &&)=delete

## Protected Types
using | TBase = std::remove_all_extents_t< T >
using | ValueType = Func

## Protected Member Functions
bool | is_array () const override
template<typename T2 = T, std::enable_if_t< !std::is_array_v< T2 > > * = nullptr>
| GeneratorOutputImpl (const std::string &name, ArgInfoKind kind, const std::vector< Type > &t, int d)
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > &&std::rank_v< T2 >==1 &&(std::extent_v< T2, 0 > > 0)> * = nullptr>
| GeneratorOutputImpl (const std::string &name, ArgInfoKind kind, const std::vector< Type > &t, int d)
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > &&std::rank_v< T2 >==1 &&std::extent_v< T2, 0 >==0 > * = nullptr>
| GeneratorOutputImpl (const std::string &name, ArgInfoKind kind, const std::vector< Type > &t, int d)
Protected Member Functions inherited from Halide::Internal::GeneratorOutputBase
template<typename T2 , std::enable_if_t< std::is_same_v< T2, Func > > * = nullptr>
HALIDE_NO_USER_CODE_INLINE T2 | as () const
| GeneratorOutputBase (size_t array_size, const std::string &name, ArgInfoKind kind, const std::vector< Type > &t, int d)
| GeneratorOutputBase (const std::string &name, ArgInfoKind kind, const std::vector< Type > &t, int d)
void | init_internals ()
void | resize (size_t size)
virtual std::string | get_c_type () const
void | check_value_writable () const override
const char * | input_or_output () const override
Protected Member Functions inherited from Halide::Internal::GIOBase
bool | array_size_defined () const
size_t | array_size () const
const std::string & | name () const
ArgInfoKind | kind () const
bool | gio_types_defined () const
const std::vector< Type > & | gio_types () const
Type | gio_type () const
bool | dims_defined () const
int | dims () const
const std::vector< Func > & | funcs () const
const std::vector< Expr > & | exprs () const
| GIOBase (size_t array_size, const std::string &name, ArgInfoKind kind, const std::vector< Type > &types, int dims)
std::string | array_name (size_t i) const
virtual void | verify_internals ()
void | check_matching_array_size (size_t size) const
void | check_matching_types (const std::vector< Type > &t) const
void | check_matching_dims (int d) const
template<typename ElemType >
const std::vector< ElemType > & | get_values () const
void | check_gio_access () const
template<>
const std::vector< Expr > & | get_values () const
template<>
const std::vector< Func > & | get_values () const

## Additional Inherited Members
Protected Attributes inherited from Halide::Internal::GIOBase
int | array_size_
const std::string | name_
const ArgInfoKind | kind_
std::vector< Type > | types_
int | dims_
std::vector< Func > | funcs_
std::vector< Expr > | exprs_
GeneratorBase * | generator {nullptr}

## Detailed Description

template<typename T>
class Halide::Internal::GeneratorOutputImpl< T >

Definition at line 2383 of file Generator.h.

## Member Typedef Documentation

## ◆ TBase

template<typename T >

using Halide::Internal::GeneratorOutputImpl< T >::TBase = std::remove_all_extents_t<T>
| protected

Definition at line 2385 of file Generator.h.

## ◆ ValueType

template<typename T >

using Halide::Internal::GeneratorOutputImpl< T >::ValueType = Func
| protected

Definition at line 2386 of file Generator.h.

## Constructor & Destructor Documentation

## ◆ GeneratorOutputImpl() [1/3]

template<typename T >
template<typename T2 = T, std::enable_if_t< !std::is_array_v< T2 > > * = nullptr>

Halide::Internal::GeneratorOutputImpl< T >::GeneratorOutputImpl | ( | const std::string & | name,
|  | ArgInfoKind | kind,
|  | const std::vector< Type > & | t,
|  | int | d
| ) |  |
| inline protected

Definition at line 2395 of file Generator.h.

## ◆ GeneratorOutputImpl() [2/3]

template<typename T >
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > &&std::rank_v< T2 >==1 &&(std::extent_v< T2, 0 > > 0)> * = nullptr>

Halide::Internal::GeneratorOutputImpl< T >::GeneratorOutputImpl | ( | const std::string & | name,
|  | ArgInfoKind | kind,
|  | const std::vector< Type > & | t,
|  | int | d
| ) |  |
| inline protected

Definition at line 2402 of file Generator.h.

## ◆ GeneratorOutputImpl() [3/3]

template<typename T >
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > &&std::rank_v< T2 >==1 &&std::extent_v< T2, 0 >==0 > * = nullptr>

Halide::Internal::GeneratorOutputImpl< T >::GeneratorOutputImpl | ( | const std::string & | name,
|  | ArgInfoKind | kind,
|  | const std::vector< Type > & | t,
|  | int | d
| ) |  |
| inline protected

Definition at line 2409 of file Generator.h.

## Member Function Documentation

## ◆ is_array()

template<typename T >

bool Halide::Internal::GeneratorOutputImpl< T >::is_array | ( |  | ) | const
| inline override protected virtual

Reimplemented from Halide::Internal::GIOBase.

Definition at line 2388 of file Generator.h.

Referenced by Halide::Internal::GeneratorOutput_Buffer< T >::operator OutputImageParam(), and Halide::Internal::GeneratorOutput_Buffer< T >::set_estimates().

## ◆ operator()() [1/2]

template<typename T >
template<typename... Args, typename T2 = T, std::enable_if_t<!std::is_array_v< T2 > > * = nullptr>

FuncRef Halide::Internal::GeneratorOutputImpl< T >::operator() | ( | Args &&... | args | ) | const
| inline

Definition at line 2415 of file Generator.h.

References Halide::cast(), and Halide::Internal::GIOBase::check_gio_access().

## ◆ operator()() [2/2]

template<typename T >
template<typename ExprOrVar , typename T2 = T, std::enable_if_t<!std::is_array_v< T2 > > * = nullptr>

FuncRef Halide::Internal::GeneratorOutputImpl< T >::operator() | ( | std::vector< ExprOrVar > | args | ) | const
| inline

Definition at line 2421 of file Generator.h.

References Halide::cast(), and Halide::Internal::GIOBase::check_gio_access().

## ◆ operator Func()

template<typename T >
template<typename T2 = T, std::enable_if_t<!std::is_array_v< T2 > > * = nullptr>

Halide::Internal::GeneratorOutputImpl< T >::operator Func | ( |  | ) | const
| inline

Definition at line 2427 of file Generator.h.

References Halide::cast(), and Halide::Internal::GIOBase::check_gio_access().

## ◆ operator Stage()

template<typename T >
template<typename T2 = T, std::enable_if_t<!std::is_array_v< T2 > > * = nullptr>

Halide::Internal::GeneratorOutputImpl< T >::operator Stage | ( |  | ) | const
| inline

Definition at line 2433 of file Generator.h.

References Halide::cast(), and Halide::Internal::GIOBase::check_gio_access().

## ◆ size()

template<typename T >
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > > * = nullptr>

size_t Halide::Internal::GeneratorOutputImpl< T >::size | ( |  | ) | const
| inline

Definition at line 2439 of file Generator.h.

References Halide::cast(), and Halide::Internal::GIOBase::check_gio_access().

## ◆ operator[]()

template<typename T >
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > > * = nullptr>

const ValueType & Halide::Internal::GeneratorOutputImpl< T >::operator[] | ( | size_t | i | ) | const
| inline

Definition at line 2445 of file Generator.h.

References Halide::cast(), and Halide::Internal::GIOBase::check_gio_access().

## ◆ at()

template<typename T >
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > > * = nullptr>

const ValueType & Halide::Internal::GeneratorOutputImpl< T >::at | ( | size_t | i | ) | const
| inline

Definition at line 2451 of file Generator.h.

References Halide::cast(), and Halide::Internal::GIOBase::check_gio_access().

## ◆ begin()

template<typename T >
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > > * = nullptr>

std::vector< ValueType >::const_iterator Halide::Internal::GeneratorOutputImpl< T >::begin | ( |  | ) | const
| inline

Definition at line 2457 of file Generator.h.

References Halide::cast(), and Halide::Internal::GIOBase::check_gio_access().

## ◆ end()

template<typename T >
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > > * = nullptr>

std::vector< ValueType >::const_iterator Halide::Internal::GeneratorOutputImpl< T >::end | ( |  | ) | const
| inline

Definition at line 2463 of file Generator.h.

References Halide::cast(), and Halide::Internal::GIOBase::check_gio_access().

## ◆ resize()

template<typename T >
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > &&std::rank_v< T2 >==1 &&std::extent_v< T2, 0 >==0 > * = nullptr>

void Halide::Internal::GeneratorOutputImpl< T >::resize | ( | size_t | size | ) |
| inline

Definition at line 2471 of file Generator.h.

References Halide::Internal::GIOBase::check_gio_access(), and Halide::Internal::GeneratorOutputBase::resize().

The documentation for this class was generated from the following file:

- src/Generator.h